//
// Xnes.h
//

// --------------------------------------------------------
// Les fonctions suivantes ont t fournis par Mr.David :))

#include "nes.h"

#define WriteBit(var, bit, pos) {ClearBit(var, pos); var |= (bit << pos);}
#define SetBit(var, pos) var |= (1 << pos)
#define ClearBit(var, pos) var &= ~(1 << pos)
#define TestBit(var, pos) (var & (1 << pos) ? 1 : 0)
#define ReadBit(x,y) ((x >> y) & 0x01)

// --------------------------------------------------------
#define         ESC             283              // Valeur de la touche ESC
#define         F12             22528             // Valeur de la touche F12
#define         F1              15104
#define         F2              15360
#define         F3              15616
#define         F4              15872
#define         F5              16128
#define         KX              11640             // KX Correspond  A
#define         KC              11875              // KC Correspond  B
#define         ENTER           7181              // ENTER Correspond  Start
#define         KS              8051             // KS Correspond  Select
#define         KP              6512             // KP Correspond  Pause:)
#define         Arrow_Up        18432
#define         Arrow_Down      20480
#define         Arrow_Left      19200
#define         Arrow_Right     19712
#define         Diag_01         18176
#define         Diag_02         18688
#define         Diag_03         20224
#define         Diag_04         20736
#define         KMo             18989
#define         KPl             20011              

#define         SnapScreen()    { save_pcx( "XNes.pcx", screen , Pallete ); }

byte *RAM,*ROM,*VRAM,*SRAM;  // Pointeur vers la     RAM Principale
byte *VROM;                  //                      ROM
                             //                      RAM Video
                             //                      RAM Sprite                                        
short   PPU_REG_6;           // Encore une ide  David
short   PPU_REG_5A;
short   PPU_REG_5B;

int     PPU_addr_toggle;     // Snifff...
int     BGScroll_toggle;     // Ca c'est une ide  moi non mais !

int     Graphic_Engine;             

int     Mirroring;
int     SVRam;
int     Battery;
int     Trainer;

int     Linear;
int     Vga;
int     ModeX;

int     MMC;
int     MMC_Table;

int     Screen_Change;

byte    Joypad_1;

char    CartName[ 80 ];
char    Battery_Name[ 80 ];

int     CheckKb( void );
int     Reset_Nes( void );
int     Quit( void );
void    Write_PPU( byte );
